.386
.model flat,stdcall
option casemap:none

include AlarmClock.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,OFFSET MenuName
	mov		wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,500
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,addr DlgName,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

ThreadProc PROC USES ecx Param:DWORD

Restart:
invoke GetLocalTime,offset time
ch_hour:
	invoke GetLocalTime,offset time
	mov ax,time.wHour
	cmp al,setHour
	je ch_minute
	jne Restart
ch_minute:
	mov ax,time.wMinute
	cmp al,setMinute
	je reset
	jne Restart
reset:
	invoke MessageBox,NULL,offset AlarmMessage,offset AlarmCaption,MB_ICONINFORMATION
	;couldnt test the soundplay feature, cause no soundcard here :-( in my office
	invoke PlaySound,502,hInstance,SND_RESOURCE
	ret
	
ThreadProc ENDP

SetTimeProc proc hSetTime:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
.if uMsg==WM_CLOSE
	invoke EndDialog,hSetTime,NULL
	ret
.elseif uMsg==WM_INITDIALOG
	invoke SendDlgItemMessage,hSetTime,IDC_EDT1,EM_LIMITTEXT,2,0
	invoke SendDlgItemMessage,hSetTime,IDC_EDT2,EM_LIMITTEXT,2,0
	
.elseif uMsg==WM_COMMAND
	mov eax,wParam
		.if ax==IDC_BTN2
			invoke GetDlgItemInt,hSetTime,IDC_EDT1,NULL,FALSE
			mov setHour,al
			invoke GetDlgItemInt,hSetTime,IDC_EDT2,NULL,FALSE
			mov setMinute,al
			invoke SendMessage,hSetTime,WM_CLOSE,NULL,NULL
		.elseif ax==IDC_BTN3
			invoke SendMessage,hSetTime,WM_CLOSE,NULL,NULL
		.endif
.else 
	mov eax,FALSE
	ret
.endif
mov eax,TRUE
ret
SetTimeProc endp
WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push		hWin
		pop		hWnd
		invoke LoadIcon,hInstance,500
		mov hIcon,eax
		invoke SendMessage,hWin,WM_SETICON,NULL,hIcon
		
		;/* setup Image on our form */
		invoke GetDlgItem,hWin,1001
		mov hImage, eax
		invoke LoadIcon,hInstance,IDC_ICON2
		mov hIcon2, eax
		invoke SendMessage,hImage,STM_SETIMAGE,IMAGE_ICON,hIcon2
		
		 ;/* Here is what we need to display date and time */	
		invoke SetTimer,hWin,0,1000, 0  ;Timer setup (in milliseconds)
 		;/* END of what we need to display date and time */
 	
 	 ;/* Here is what we need to display date and time */	
 	.elseif eax==WM_TIMER
 		invoke GetLocalTime, offset time
		invoke GetDateFormat, LOCALE_USER_DEFAULT, NULL,offset time,offset dateformat, offset dbuffer, sizeof dbuffer
		invoke GetTimeFormat, LOCALE_USER_DEFAULT,NULL,offset time, offset timeformat, offset sbuffer, sizeof sbuffer

		invoke SendDlgItemMessage,hWin,1003,WM_SETTEXT,0,offset sbuffer
		invoke SendDlgItemMessage,hWin,1004,WM_SETTEXT,0,offset dbuffer
	;/* END of what we need to display date and time */
		
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,hIcon
		.elseif eax==IDC_BTN1
			invoke CreateDialogParam,hInstance,IDD_DLG1,hWin,offset SetTimeProc,FALSE	
			mov  eax,OFFSET ThreadProc
			invoke CreateThread,NULL,NULL,eax,\
                                        NULL,IDLE_PRIORITY_CLASS,\
                                        ADDR ThreadID
			invoke SetThreadPriority,eax,THREAD_PRIORITY_LOWEST				
			invoke CloseHandle,eax
		.endif
		
	
	.elseif eax==WM_CLOSE
		;*/ we could kill the timer here... */
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
